#include "main.h"

//HVD232---CAN_TX---PB9
//HVD232---CAN_RX---PB8

void CAN_Configuration(void)
{
	CAN_InitTypeDef        can;
	CAN_FilterInitTypeDef  can_filter;
	GPIO_InitTypeDef 	   gpio;
	NVIC_InitTypeDef   	   nvic;

	RCC_APB1PeriphClockCmd(RCC_APB1Periph_CAN1,  ENABLE);
	RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOB |
                           RCC_APB2Periph_AFIO , ENABLE);
    
    GPIO_PinRemapConfig(GPIO_Remap1_CAN1,ENABLE);
    
	gpio.GPIO_Pin = GPIO_Pin_8;
	gpio.GPIO_Mode = GPIO_Mode_IPU;
    gpio.GPIO_Speed = GPIO_Speed_50MHz;
	GPIO_Init(GPIOB, &gpio);	//CAN_RX
	
	gpio.GPIO_Pin = GPIO_Pin_9;	   
    gpio.GPIO_Mode = GPIO_Mode_AF_PP;
	gpio.GPIO_Speed = GPIO_Speed_50MHz;
	GPIO_Init(GPIOB, &gpio);    //CAN_TX

    nvic.NVIC_IRQChannel = USB_HP_CAN1_TX_IRQn;
    nvic.NVIC_IRQChannelPreemptionPriority = 1;
    nvic.NVIC_IRQChannelSubPriority = 0;
    nvic.NVIC_IRQChannelCmd = ENABLE;
    NVIC_Init(&nvic);
    
    nvic.NVIC_IRQChannel = USB_LP_CAN1_RX0_IRQn;  
    nvic.NVIC_IRQChannelPreemptionPriority = 1;
    nvic.NVIC_IRQChannelSubPriority = 1;
    nvic.NVIC_IRQChannelCmd = ENABLE;
    NVIC_Init(&nvic);

	CAN_DeInit(CAN1);

	can.CAN_TTCM=ENABLE;		//ʹʱ䴥ģʽ
	can.CAN_ABOM=ENABLE;		//ʹԶ߹
	can.CAN_AWUM=ENABLE;		//ʹԶ
	can.CAN_NART=DISABLE;		//ENABLE:Զش DISABLE:ش
	can.CAN_RFLM=DISABLE;		//ʧFIFO
	can.CAN_TXFP=DISABLE;		//ʧܷFIFOȼ		
 	can.CAN_Mode = CAN_Mode_Normal;
	can.CAN_SJW = CAN_SJW_1tq;
	can.CAN_BS1 = CAN_BS1_5tq;
	can.CAN_BS2 = CAN_BS2_3tq;
	can.CAN_Prescaler = 4;     //CAN BaudRate 36/(1+5+3)/4=1Mbps
	CAN_Init(CAN1, &can);
	
	can_filter.CAN_FilterNumber = 0; 
	can_filter.CAN_FilterMode = CAN_FilterMode_IdMask;
	can_filter.CAN_FilterScale = CAN_FilterScale_32bit;
	can_filter.CAN_FilterIdHigh = (((u32)BASE_MOTOR_ID<<21)&0xFFFF0000)>>16;	   //趨ʶ
	can_filter.CAN_FilterIdLow = 0x0000;//趨ʶ
	can_filter.CAN_FilterMaskIdHigh = 0xffe0;//趨αʶ
	can_filter.CAN_FilterMaskIdLow = 0;
	
	can_filter.CAN_FilterFIFOAssignment = 0;
	can_filter.CAN_FilterActivation = ENABLE;
	CAN_FilterInit(&can_filter);
    
    CAN_ITConfig(CAN1,CAN_IT_FMP0,ENABLE);
//    CAN_ITConfig(CAN1,CAN_IT_TME,ENABLE);
}

void USB_LP_CAN1_RX0_IRQHandler(void)
{
    CanRxMsg rx_message;
  //  CAN_Receive(CAN1, CAN_FIFO0, &rx_message);
		
		
	if (CAN_GetITStatus(CAN1,CAN_IT_FMP0)!= RESET)
	{
        CAN_ClearITPendingBit(CAN1, CAN_IT_FMP0);
        CAN_Receive(CAN1, CAN_FIFO0, &rx_message);
		CANPutDatatoRxBuf(&rx_message);	//ѽյݴŵ
	//	CanMsgDeal();
   }
}

void USB_HP_CAN1_TX_IRQHandler(void)
{
	if(CANIsDataInTxBuf() == 1)
	{
		CAN_Transmit(CAN1, CANGetTxBufDat());
	}
	else
	{
		CANStopSend();
	}
}


//CAN
static CanRxMsg CAN_RX_Buf[CAN_RX_BUF_MAX];		//Ͷ
static CanTxMsg CAN_TX_Buf[CAN_TX_BUF_MAX];		//ն

volatile u32 CAN_Rx_Head = 0;					//ͷ-յʱƶ
volatile u32 CAN_Rx_Tail = 0;					//β-ȡʱƶ

volatile u32 CAN_Tx_Head = 0;					//ͷ-յʱƶ
volatile u32 CAN_Tx_Tail = 0;					//β-ȡʱƶ

/*------------------------------------------------------------------
                    ºй
------------------------------------------------------------------*/

/**************************************************************
** :CANPutDatatoRxBuf
** :ݷŽ
** ע:Ӧڴڽжеô˺
***************************************************************/
void CANPutDatatoRxBuf(CanRxMsg *pRxMessage)
{
	u32 tmphead;
	tmphead = ( CAN_Rx_Head + 1 ) & CAN_RX_BUF_MARK;//ͷֵж,,0
	CAN_Rx_Head = tmphead; 					// ÿһ,ͷ1 
	CAN_RX_Buf[tmphead] = *pRxMessage; 		// ѽյݷŽ 		
}
/*************************************************
**:CANIsDataInRxBuf
**:֪Ƿ
**ע:еͷβȵʱ,ʹڻ
*************************************************/
u8 CANIsDataInRxBuf( void )
{
	if( CAN_Rx_Head == CAN_Rx_Tail )
		return 0;
	else 
		return 1; 
}
/*************************************************
**:CANGetRxBufLen
**:ȡЧݵĳ
**ע:ȡֵȻΪСֵ,ΪʵȻ᲻ϱ仯.32λARMϵͳ,ȡ32λݲٽ,ԿԲǹж
**************************************************/
u32 CANGetRxBufLen(void)
{
	//__disalbe_irq();
	if(CAN_Rx_Head >= CAN_Rx_Tail)
	{
		//__enable_irq();	
		return(CAN_Rx_Head - CAN_Rx_Tail);
	}
	else
	{
		//__enable_irq();	
		return(CAN_RX_BUF_MAX + CAN_Rx_Head - CAN_Rx_Tail);
	}
}
/**************************************************
**:CANGetRxBufDat
**:Ӷлȡ
**ע:ô˺ǰȷ!!Ӳȴ
**************************************************/
CanRxMsg *CANGetRxBufDat( void )
{
	u32 tmptail;
	while ( CAN_Rx_Head == CAN_Rx_Tail );//ΪֹݻҶŪϵӲȴ
	tmptail = ( CAN_Rx_Tail + 1 ) & CAN_RX_BUF_MARK;
	CAN_Rx_Tail = tmptail;
	return &CAN_RX_Buf[tmptail];		 //ضеȴݵĵַ
}


/*------------------------------------------------------------------
                    º뷢й
------------------------------------------------------------------*/

/**************************************************************
** :CANPutDatatoTxBuf
** :ݷŽͶ
** ע:ûҪݷʱʹ
***************************************************************/
u8 CANPutDatatoTxBuf(CanTxMsg *pTxMessage)
{
	u32 tmphead;
	tmphead = ( CAN_Tx_Head + 1 ) & CAN_TX_BUF_MARK;//ĩж,ĩ,0
	if(tmphead == CAN_Tx_Tail)
		return 0;
	
	CAN_Tx_Head = tmphead; 	// ÿ,ͷ1 
	CAN_TX_Buf[tmphead] = *pTxMessage; 	
	return 1;			
}

/*************************************************
**:CANIsDataInTxBuf
**:֪Ƿ
**ע:еͷβȵʱ,ʹڻ
*************************************************/
u8 CANIsDataInTxBuf( void )
{
	if( CAN_Tx_Head == CAN_Tx_Tail )
		return 0;
	else 
		return 1; 
}

/*************************************************
**:CANGetTxBufLen
**:ȡЧݵĳ
**ע:ȡֵȻΪСֵ,ΪʵȻ᲻ϱ仯.32λARMϵͳ,ȡ32λݲٽ,ԿԲǹж
**			νЧ,ָʣĿó
**************************************************/
u32 CANGetTxBufLen(void)
{
	//__disalbe_irq();
	if(CAN_Tx_Head >= CAN_Tx_Tail)
	{
		//__enable_irq();	
		return(CAN_TX_BUF_MAX - (CAN_Tx_Head-CAN_Tx_Tail));
	}
	else
	{
		//__enable_irq();	
		return(CAN_Tx_Tail - CAN_Tx_Head);
	}
}
/**************************************************
**:CANGetTxBufDat
**:Ӷлȡ
**ע:ô˺ǰȷ!!
**************************************************/
CanTxMsg *CANGetTxBufDat( void )
{
	u32 tmptail;
	while ( CAN_Tx_Head == CAN_Tx_Tail );//ΪֹݻҶŪϵӲȴ
	tmptail = ( CAN_Tx_Tail + 1 ) & CAN_TX_BUF_MARK;
	CAN_Tx_Tail = tmptail;
	return &CAN_TX_Buf[tmptail];
}

/*******************************************************
**:CANBeginSend/StopSend
**:
**ע:ʹÿжϷʽ,ֻҪͼĴΪ,뷢Ϳж,ϵͳжнз
********************************************************/
void CANBeginSend(void)
{
//	CAN_ITConfig(CAN1,CAN_IT_TME, ENABLE);//ж
	CAN1->IER |= CAN_IT_TME;
}
void CANStopSend(void)
{
	CAN1->IER &= ~CAN_IT_TME;
}
