#include "main.h"

//PWM
void Motor_Turn(ST_MOTOR *st_motor)
{
	if(st_motor->PWM_Duty >0)
	{
		GPIOA->BSRR |= (1<<10);
		GPIOA->BSRR |= (1<<24);
		TIM1->CCR4 = 0;
		if(st_motor->PWM_Duty >= 4800)
		{
			TIM1->CCR2 = 4800;
		}
		else
		{
			TIM1->CCR2 = st_motor->PWM_Duty;
		}
	}
	else
	{
		TIM1->CCR2 = 0;
		GPIOA->BSRR |= (1<<26);
		GPIOA->BSRR |= (1<<8);
		if(st_motor->PWM_Duty <= -4800)
		{
			TIM1->CCR4 = 4800;
		}
		else
		{
			TIM1->CCR4 = -st_motor->PWM_Duty;
		}
	}
}

//ٶ
void CalVelt(ST_MOTOR *st_motor)
{
	int x=0;
	if(st_motor->coder_state == FIRST)
	{
		st_motor->coder_state=RUN;
		TIM3->CNT=0;
		st_motor->codernum_now=0;
		st_motor->codernum_pre=0;
		st_motor->codernum_sum=0;
		st_motor->Velt=0;
	}
	else if(st_motor->coder_state == RUN)
	{
		st_motor->codernum_now=TIM3->CNT;
		x=st_motor->codernum_now-st_motor->codernum_pre;
		if(x>20000)
		{
			x=x-0xffff;
		}
		else if(x<-20000)
		{
			x=x+0xffff;
		}
		st_motor->codernum_sum = x;
		st_motor->Velt = x*1.875;
		st_motor->codernum_pre=st_motor->codernum_now;
	}
}

//ٶȱջ
void VeltLoop(ST_MOTOR *st_motor,ST_PID *st_pid)
{
	float x=0;
	st_pid->E = st_motor->VeltDes - st_motor->Velt;
	if(st_pid->E < st_pid->Edead && st_pid->E > -st_pid->Edead)
	{
		st_pid->E = 0;
	}
	if((st_pid->U >= st_pid->Ulimit && st_pid->E > 0) || (st_pid->U <= -st_pid->Ulimit && st_pid->E < 0))
	{
		st_pid->U += (st_pid->E - st_pid->PreE) * st_pid->P + (st_pid->E - 2*st_pid->PreE + st_pid->PrePreE) * st_pid->D;
	}
	else
	{
		st_pid->U += (st_pid->E - st_pid->PreE) * st_pid->P + st_pid->E * st_pid->I + (st_pid->E - 2*st_pid->PreE + st_pid->PrePreE) * st_pid->D;
	}
	st_pid->PrePreE = st_pid->PreE;
	st_pid->PreE = st_pid->E;
	x = st_pid->U;
	if(x >= 4900)
	{
		st_motor->PWM_Duty = 4900;
	}
	else if(x <= -4900)
	{
		st_motor->PWM_Duty = -4900;
	}
	st_motor->PWM_Duty = (int)x;
	Motor_Turn(st_motor);
}
